// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
import { APIResource } from '@mux/mux-node/resource';
import { isRequestOptions } from '@mux/mux-node/core';
import * as DimensionsAPI from '@mux/mux-node/resources/data/dimensions';
import { BasePage } from '@mux/mux-node/pagination';
export class Dimensions extends APIResource {
    /**
     * List all available dimensions.
     *
     * Note: This API replaces the list-filters API call.
     */
    list(options) {
        return this._client.get('/data/v1/dimensions', options);
    }
    listValues(dimensionId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.listValues(dimensionId, {}, query);
        }
        return this._client.getAPIList(`/data/v1/dimensions/${dimensionId}`, DimensionValuesBasePage, {
            query,
            ...options,
        });
    }
}
export class DimensionValuesBasePage extends BasePage {
}
(function (Dimensions) {
    Dimensions.DimensionValuesBasePage = DimensionsAPI.DimensionValuesBasePage;
})(Dimensions || (Dimensions = {}));
//# sourceMappingURL=dimensions.mjs.map