import * as Core from '@mux/mux-node/core';
import { APIResource } from '@mux/mux-node/resource';
import * as ExportsAPI from '@mux/mux-node/resources/data/exports';
export declare class Exports extends APIResource {
    /**
     * Lists the available video view exports along with URLs to retrieve them.
     */
    listVideoViews(options?: Core.RequestOptions): Core.APIPromise<VideoViewExportsResponse>;
}
export interface ExportsResponse {
    data: Array<string>;
    timeframe: Array<number>;
    total_row_count: number | null;
}
export interface VideoViewExportsResponse {
    data: Array<VideoViewExportsResponse.Data>;
    timeframe: Array<number>;
    total_row_count: number | null;
}
export declare namespace VideoViewExportsResponse {
    interface Data {
        export_date: string;
        files: Array<Data.File>;
    }
    namespace Data {
        interface File {
            path: string;
            type: string;
            version: number;
        }
    }
}
export declare namespace Exports {
    export import ExportsResponse = ExportsAPI.ExportsResponse;
    export import VideoViewExportsResponse = ExportsAPI.VideoViewExportsResponse;
}
//# sourceMappingURL=exports.d.ts.map