// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
import { APIResource } from '@mux/mux-node/resource';
import { isRequestOptions } from '@mux/mux-node/core';
import * as IncidentsAPI from '@mux/mux-node/resources/data/incidents';
import { BasePage } from '@mux/mux-node/pagination';
export class Incidents extends APIResource {
    /**
     * Returns the details of an incident.
     */
    retrieve(incidentId, options) {
        return this._client.get(`/data/v1/incidents/${incidentId}`, options);
    }
    list(query = {}, options) {
        if (isRequestOptions(query)) {
            return this.list({}, query);
        }
        return this._client.getAPIList('/data/v1/incidents', IncidentsBasePage, { query, ...options });
    }
    listRelated(incidentId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.listRelated(incidentId, {}, query);
        }
        return this._client.getAPIList(`/data/v1/incidents/${incidentId}/related`, IncidentsBasePage, {
            query,
            ...options,
        });
    }
}
export class IncidentsBasePage extends BasePage {
}
(function (Incidents) {
    Incidents.IncidentsBasePage = IncidentsAPI.IncidentsBasePage;
})(Incidents || (Incidents = {}));
//# sourceMappingURL=incidents.mjs.map