// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
import { APIResource } from '@mux/mux-node/resource';
import { isRequestOptions } from '@mux/mux-node/core';
export class Metrics extends APIResource {
    /**
     * Lists available monitoring metrics.
     */
    list(options) {
        return this._client.get('/data/v1/monitoring/metrics', options);
    }
    getBreakdown(monitoringMetricId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.getBreakdown(monitoringMetricId, {}, query);
        }
        return this._client.get(`/data/v1/monitoring/metrics/${monitoringMetricId}/breakdown`, {
            query,
            ...options,
        });
    }
    getBreakdownTimeseries(monitoringMetricId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.getBreakdownTimeseries(monitoringMetricId, {}, query);
        }
        return this._client.get(`/data/v1/monitoring/metrics/${monitoringMetricId}/breakdown-timeseries`, {
            query,
            ...options,
        });
    }
    getHistogramTimeseries(monitoringHistogramMetricId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.getHistogramTimeseries(monitoringHistogramMetricId, {}, query);
        }
        return this._client.get(`/data/v1/monitoring/metrics/${monitoringHistogramMetricId}/histogram-timeseries`, { query, ...options });
    }
    getTimeseries(monitoringMetricId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.getTimeseries(monitoringMetricId, {}, query);
        }
        return this._client.get(`/data/v1/monitoring/metrics/${monitoringMetricId}/timeseries`, {
            query,
            ...options,
        });
    }
}
(function (Metrics) {
})(Metrics || (Metrics = {}));
//# sourceMappingURL=metrics.mjs.map