"use strict";
// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
Object.defineProperty(exports, "__esModule", { value: true });
exports.RealTime = void 0;
const resource_1 = require("@mux/mux-node/resource");
const core_1 = require("@mux/mux-node/core");
class RealTime extends resource_1.APIResource {
    /**
     * Lists available real-time dimensions. This API is now deprecated, please use the
     * `List Monitoring Dimensions` API.
     */
    listDimensions(options) {
        return this._client.get('/data/v1/realtime/dimensions', options);
    }
    /**
     * Lists available real-time metrics. This API is now deprecated, please use the
     * `List Monitoring Metrics` API.
     */
    listMetrics(options) {
        return this._client.get('/data/v1/realtime/metrics', options);
    }
    retrieveBreakdown(realtimeMetricId, query = {}, options) {
        if ((0, core_1.isRequestOptions)(query)) {
            return this.retrieveBreakdown(realtimeMetricId, {}, query);
        }
        return this._client.get(`/data/v1/realtime/metrics/${realtimeMetricId}/breakdown`, { query, ...options });
    }
    retrieveHistogramTimeseries(realtimeHistogramMetricId, query = {}, options) {
        if ((0, core_1.isRequestOptions)(query)) {
            return this.retrieveHistogramTimeseries(realtimeHistogramMetricId, {}, query);
        }
        return this._client.get(`/data/v1/realtime/metrics/${realtimeHistogramMetricId}/histogram-timeseries`, {
            query,
            ...options,
        });
    }
    retrieveTimeseries(realtimeMetricId, query = {}, options) {
        if ((0, core_1.isRequestOptions)(query)) {
            return this.retrieveTimeseries(realtimeMetricId, {}, query);
        }
        return this._client.get(`/data/v1/realtime/metrics/${realtimeMetricId}/timeseries`, {
            query,
            ...options,
        });
    }
}
exports.RealTime = RealTime;
(function (RealTime) {
})(RealTime = exports.RealTime || (exports.RealTime = {}));
//# sourceMappingURL=real-time.js.map