// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
import { APIResource } from '@mux/mux-node/resource';
import { isRequestOptions } from '@mux/mux-node/core';
export class RealTime extends APIResource {
    /**
     * Lists available real-time dimensions. This API is now deprecated, please use the
     * `List Monitoring Dimensions` API.
     */
    listDimensions(options) {
        return this._client.get('/data/v1/realtime/dimensions', options);
    }
    /**
     * Lists available real-time metrics. This API is now deprecated, please use the
     * `List Monitoring Metrics` API.
     */
    listMetrics(options) {
        return this._client.get('/data/v1/realtime/metrics', options);
    }
    retrieveBreakdown(realtimeMetricId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.retrieveBreakdown(realtimeMetricId, {}, query);
        }
        return this._client.get(`/data/v1/realtime/metrics/${realtimeMetricId}/breakdown`, { query, ...options });
    }
    retrieveHistogramTimeseries(realtimeHistogramMetricId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.retrieveHistogramTimeseries(realtimeHistogramMetricId, {}, query);
        }
        return this._client.get(`/data/v1/realtime/metrics/${realtimeHistogramMetricId}/histogram-timeseries`, {
            query,
            ...options,
        });
    }
    retrieveTimeseries(realtimeMetricId, query = {}, options) {
        if (isRequestOptions(query)) {
            return this.retrieveTimeseries(realtimeMetricId, {}, query);
        }
        return this._client.get(`/data/v1/realtime/metrics/${realtimeMetricId}/timeseries`, {
            query,
            ...options,
        });
    }
}
(function (RealTime) {
})(RealTime || (RealTime = {}));
//# sourceMappingURL=real-time.mjs.map