import * as Core from '@mux/mux-node/core';
import { APIResource } from '@mux/mux-node/resource';
import * as DRMConfigurationsAPI from '@mux/mux-node/resources/video/drm-configurations';
import { BasePage, type BasePageParams } from '@mux/mux-node/pagination';
export declare class DRMConfigurations extends APIResource {
    /**
     * Retrieves a single DRM Configuration.
     */
    retrieve(drmConfigurationId: string, options?: Core.RequestOptions): Core.APIPromise<DRMConfiguration>;
    /**
     * Returns a list of DRM Configurations
     */
    list(query?: DRMConfigurationListParams, options?: Core.RequestOptions): Core.PagePromise<DRMConfigurationsBasePage, DRMConfiguration>;
    list(options?: Core.RequestOptions): Core.PagePromise<DRMConfigurationsBasePage, DRMConfiguration>;
}
export declare class DRMConfigurationsBasePage extends BasePage<DRMConfiguration> {
}
export interface DRMConfiguration {
    /**
     * Unique identifier for the DRM Configuration. Max 255 characters.
     */
    id: string;
}
export interface DRMConfigurationListParams extends BasePageParams {
}
export declare namespace DRMConfigurations {
    export import DRMConfiguration = DRMConfigurationsAPI.DRMConfiguration;
    export import DRMConfigurationsBasePage = DRMConfigurationsAPI.DRMConfigurationsBasePage;
    export import DRMConfigurationListParams = DRMConfigurationsAPI.DRMConfigurationListParams;
}
//# sourceMappingURL=drm-configurations.d.ts.map