// File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.
import { APIResource } from '@mux/mux-node/resource';
import { isRequestOptions } from '@mux/mux-node/core';
import * as DRMConfigurationsAPI from '@mux/mux-node/resources/video/drm-configurations';
import { BasePage } from '@mux/mux-node/pagination';
export class DRMConfigurations extends APIResource {
    /**
     * Retrieves a single DRM Configuration.
     */
    retrieve(drmConfigurationId, options) {
        return this._client.get(`/video/v1/drm-configurations/${drmConfigurationId}`, options)._thenUnwrap((obj) => obj.data);
    }
    list(query = {}, options) {
        if (isRequestOptions(query)) {
            return this.list({}, query);
        }
        return this._client.getAPIList('/video/v1/drm-configurations', DRMConfigurationsBasePage, {
            query,
            ...options,
        });
    }
}
export class DRMConfigurationsBasePage extends BasePage {
}
(function (DRMConfigurations) {
    DRMConfigurations.DRMConfigurationsBasePage = DRMConfigurationsAPI.DRMConfigurationsBasePage;
})(DRMConfigurations || (DRMConfigurations = {}));
//# sourceMappingURL=drm-configurations.mjs.map