import { APIResource } from '@mux/mux-node/resource';
import * as AssetsAPI from '@mux/mux-node/resources/video/assets';
import * as DeliveryUsageAPI from '@mux/mux-node/resources/video/delivery-usage';
import * as DRMConfigurationsAPI from '@mux/mux-node/resources/video/drm-configurations';
import * as LiveStreamsAPI from '@mux/mux-node/resources/video/live-streams';
import * as PlaybackIDsAPI from '@mux/mux-node/resources/video/playback-ids';
import * as PlaybackRestrictionsAPI from '@mux/mux-node/resources/video/playback-restrictions';
import * as SpacesAPI from '@mux/mux-node/resources/video/spaces';
import * as TranscriptionVocabulariesAPI from '@mux/mux-node/resources/video/transcription-vocabularies';
import * as UploadsAPI from '@mux/mux-node/resources/video/uploads';
import * as WebInputsAPI from '@mux/mux-node/resources/video/web-inputs';
export declare class Video extends APIResource {
    assets: AssetsAPI.Assets;
    deliveryUsage: DeliveryUsageAPI.DeliveryUsage;
    liveStreams: LiveStreamsAPI.LiveStreams;
    playbackIds: PlaybackIDsAPI.PlaybackIDs;
    playbackRestrictions: PlaybackRestrictionsAPI.PlaybackRestrictions;
    spaces: SpacesAPI.Spaces;
    transcriptionVocabularies: TranscriptionVocabulariesAPI.TranscriptionVocabularies;
    uploads: UploadsAPI.Uploads;
    webInputs: WebInputsAPI.WebInputs;
    drmConfigurations: DRMConfigurationsAPI.DRMConfigurations;
}
export declare namespace Video {
    export import Assets = AssetsAPI.Assets;
    export import Asset = AssetsAPI.Asset;
    export import AssetOptions = AssetsAPI.AssetOptions;
    export import AssetResponse = AssetsAPI.AssetResponse;
    export import InputInfo = AssetsAPI.InputInfo;
    export import Track = AssetsAPI.Track;
    export import AssetGenerateSubtitlesResponse = AssetsAPI.AssetGenerateSubtitlesResponse;
    export import AssetRetrieveInputInfoResponse = AssetsAPI.AssetRetrieveInputInfoResponse;
    export import AssetsBasePage = AssetsAPI.AssetsBasePage;
    export import AssetCreateParams = AssetsAPI.AssetCreateParams;
    export import AssetUpdateParams = AssetsAPI.AssetUpdateParams;
    export import AssetListParams = AssetsAPI.AssetListParams;
    export import AssetCreatePlaybackIDParams = AssetsAPI.AssetCreatePlaybackIDParams;
    export import AssetCreateTrackParams = AssetsAPI.AssetCreateTrackParams;
    export import AssetGenerateSubtitlesParams = AssetsAPI.AssetGenerateSubtitlesParams;
    export import AssetUpdateMasterAccessParams = AssetsAPI.AssetUpdateMasterAccessParams;
    export import AssetUpdateMP4SupportParams = AssetsAPI.AssetUpdateMP4SupportParams;
    export import DeliveryUsage = DeliveryUsageAPI.DeliveryUsage;
    export import DeliveryReport = DeliveryUsageAPI.DeliveryReport;
    export import DeliveryReportsPageWithTotal = DeliveryUsageAPI.DeliveryReportsPageWithTotal;
    export import DeliveryUsageListParams = DeliveryUsageAPI.DeliveryUsageListParams;
    export import LiveStreams = LiveStreamsAPI.LiveStreams;
    export import LiveStream = LiveStreamsAPI.LiveStream;
    export import SimulcastTarget = LiveStreamsAPI.SimulcastTarget;
    export import LiveStreamsBasePage = LiveStreamsAPI.LiveStreamsBasePage;
    export import LiveStreamCreateParams = LiveStreamsAPI.LiveStreamCreateParams;
    export import LiveStreamUpdateParams = LiveStreamsAPI.LiveStreamUpdateParams;
    export import LiveStreamListParams = LiveStreamsAPI.LiveStreamListParams;
    export import LiveStreamCreatePlaybackIDParams = LiveStreamsAPI.LiveStreamCreatePlaybackIDParams;
    export import LiveStreamCreateSimulcastTargetParams = LiveStreamsAPI.LiveStreamCreateSimulcastTargetParams;
    export import LiveStreamUpdateEmbeddedSubtitlesParams = LiveStreamsAPI.LiveStreamUpdateEmbeddedSubtitlesParams;
    export import LiveStreamUpdateGeneratedSubtitlesParams = LiveStreamsAPI.LiveStreamUpdateGeneratedSubtitlesParams;
    export import PlaybackIDs = PlaybackIDsAPI.PlaybackIDs;
    export import PlaybackIDRetrieveResponse = PlaybackIDsAPI.PlaybackIDRetrieveResponse;
    export import PlaybackRestrictions = PlaybackRestrictionsAPI.PlaybackRestrictions;
    export import PlaybackRestriction = PlaybackRestrictionsAPI.PlaybackRestriction;
    export import PlaybackRestrictionResponse = PlaybackRestrictionsAPI.PlaybackRestrictionResponse;
    export import PlaybackRestrictionsBasePage = PlaybackRestrictionsAPI.PlaybackRestrictionsBasePage;
    export import PlaybackRestrictionCreateParams = PlaybackRestrictionsAPI.PlaybackRestrictionCreateParams;
    export import PlaybackRestrictionListParams = PlaybackRestrictionsAPI.PlaybackRestrictionListParams;
    export import PlaybackRestrictionUpdateReferrerParams = PlaybackRestrictionsAPI.PlaybackRestrictionUpdateReferrerParams;
    export import PlaybackRestrictionUpdateUserAgentParams = PlaybackRestrictionsAPI.PlaybackRestrictionUpdateUserAgentParams;
    export import Spaces = SpacesAPI.Spaces;
    export import Broadcast = SpacesAPI.Broadcast;
    export import BroadcastLayout = SpacesAPI.BroadcastLayout;
    export import BroadcastResolution = SpacesAPI.BroadcastResolution;
    export import BroadcastResponse = SpacesAPI.BroadcastResponse;
    export import BroadcastStatus = SpacesAPI.BroadcastStatus;
    export import Space = SpacesAPI.Space;
    export import SpaceResponse = SpacesAPI.SpaceResponse;
    export import SpaceStatus = SpacesAPI.SpaceStatus;
    export import SpaceType = SpacesAPI.SpaceType;
    export import SpacesBasePage = SpacesAPI.SpacesBasePage;
    export import SpaceCreateParams = SpacesAPI.SpaceCreateParams;
    export import SpaceListParams = SpacesAPI.SpaceListParams;
    export import SpaceCreateBroadcastParams = SpacesAPI.SpaceCreateBroadcastParams;
    export import TranscriptionVocabularies = TranscriptionVocabulariesAPI.TranscriptionVocabularies;
    export import TranscriptionVocabulary = TranscriptionVocabulariesAPI.TranscriptionVocabulary;
    export import TranscriptionVocabularyResponse = TranscriptionVocabulariesAPI.TranscriptionVocabularyResponse;
    export import TranscriptionVocabulariesBasePage = TranscriptionVocabulariesAPI.TranscriptionVocabulariesBasePage;
    export import TranscriptionVocabularyCreateParams = TranscriptionVocabulariesAPI.TranscriptionVocabularyCreateParams;
    export import TranscriptionVocabularyUpdateParams = TranscriptionVocabulariesAPI.TranscriptionVocabularyUpdateParams;
    export import TranscriptionVocabularyListParams = TranscriptionVocabulariesAPI.TranscriptionVocabularyListParams;
    export import Uploads = UploadsAPI.Uploads;
    export import Upload = UploadsAPI.Upload;
    export import UploadResponse = UploadsAPI.UploadResponse;
    export import UploadsBasePage = UploadsAPI.UploadsBasePage;
    export import UploadCreateParams = UploadsAPI.UploadCreateParams;
    export import UploadListParams = UploadsAPI.UploadListParams;
    export import WebInputs = WebInputsAPI.WebInputs;
    export import WebInputCreateResponse = WebInputsAPI.WebInputCreateResponse;
    export import WebInputRetrieveResponse = WebInputsAPI.WebInputRetrieveResponse;
    export import WebInputListResponse = WebInputsAPI.WebInputListResponse;
    export import WebInputLaunchResponse = WebInputsAPI.WebInputLaunchResponse;
    export import WebInputReloadResponse = WebInputsAPI.WebInputReloadResponse;
    export import WebInputShutdownResponse = WebInputsAPI.WebInputShutdownResponse;
    export import WebInputUpdateURLResponse = WebInputsAPI.WebInputUpdateURLResponse;
    export import WebInputListResponsesBasePage = WebInputsAPI.WebInputListResponsesBasePage;
    export import WebInputCreateParams = WebInputsAPI.WebInputCreateParams;
    export import WebInputListParams = WebInputsAPI.WebInputListParams;
    export import WebInputUpdateURLParams = WebInputsAPI.WebInputUpdateURLParams;
    export import DRMConfigurations = DRMConfigurationsAPI.DRMConfigurations;
    export import DRMConfiguration = DRMConfigurationsAPI.DRMConfiguration;
    export import DRMConfigurationsBasePage = DRMConfigurationsAPI.DRMConfigurationsBasePage;
    export import DRMConfigurationListParams = DRMConfigurationsAPI.DRMConfigurationListParams;
}
//# sourceMappingURL=video.d.ts.map