var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var media_rendition_selectmenu_exports = {};
__export(media_rendition_selectmenu_exports, {
  MediaRenditionSelectMenu: () => MediaRenditionSelectMenu,
  default: () => media_rendition_selectmenu_default
});
module.exports = __toCommonJS(media_rendition_selectmenu_exports);
var import_media_chrome_selectmenu = require("./media-chrome-selectmenu.js");
var import_media_rendition_button = require("./media-rendition-button.js");
var import_media_rendition_listbox = require("./media-rendition-listbox.js");
var import_constants = require("../constants.js");
var import_server_safe_globals = require("../utils/server-safe-globals.js");
class MediaRenditionSelectMenu extends import_media_chrome_selectmenu.MediaChromeSelectMenu {
  static get observedAttributes() {
    return [
      ...super.observedAttributes,
      import_constants.MediaUIAttributes.MEDIA_RENDITION_SELECTED,
      import_constants.MediaUIAttributes.MEDIA_RENDITION_UNAVAILABLE
    ];
  }
  init() {
    const renditionButton = import_server_safe_globals.document.createElement("media-rendition-button");
    renditionButton.part.add("button");
    renditionButton.preventClick = true;
    const renditionListbox = import_server_safe_globals.document.createElement("media-rendition-listbox");
    renditionListbox.part.add("listbox");
    renditionListbox.setAttribute(
      "exportparts",
      "option, option-selected, indicator"
    );
    const buttonSlot = this.shadowRoot.querySelector("slot[name=button]");
    const listboxSlot = this.shadowRoot.querySelector("slot[name=listbox]");
    buttonSlot.textContent = "";
    listboxSlot.textContent = "";
    buttonSlot.append(renditionButton);
    listboxSlot.append(renditionListbox);
  }
}
if (!import_server_safe_globals.globalThis.customElements.get("media-rendition-selectmenu")) {
  import_server_safe_globals.globalThis.customElements.define(
    "media-rendition-selectmenu",
    MediaRenditionSelectMenu
  );
}
var media_rendition_selectmenu_default = MediaRenditionSelectMenu;
