export default MediaRenditionButton;
/**
 * @attr {string} mediarenditionselected - (read-only) Set to the selected rendition id.
 * @attr {(unavailable|unsupported)} mediarenditionunavailable - (read-only) Set if rendition selection is unavailable.
 *
 * @cssproperty [--media-rendition-button-display = inline-flex] - `display` property of button.
 */
export class MediaRenditionButton extends MediaChromeButton {
    constructor();
    set mediaRenditionSelected(arg: string);
    /**
     * Get selected rendition id.
     * @return {string}
     */
    get mediaRenditionSelected(): string;
}
import { MediaChromeButton } from "../media-chrome-button.js";
