export default MediaAudioTrackMenuButton;
/**
 * @attr {string} mediaaudiotrackenabled - (read-only) Set to the selected audio track id.
 * @attr {(unavailable|unsupported)} mediaaudiotrackunavailable - (read-only) Set if audio track selection is unavailable.
 *
 * @cssproperty [--media-audio-track-menu-button-display = inline-flex] - `display` property of button.
 */
export class MediaAudioTrackMenuButton extends MediaChromeMenuButton {
    constructor();
    set mediaAudioTrackEnabled(arg: string);
    /**
     * Get enabled audio track id.
     * @return {string}
     */
    get mediaAudioTrackEnabled(): string;
}
import { MediaChromeMenuButton } from "./media-chrome-menu-button.js";
