export default MediaRenditionMenuButton;
/**
 * @attr {string} mediarenditionselected - (read-only) Set to the selected rendition id.
 * @attr {(unavailable|unsupported)} mediarenditionunavailable - (read-only) Set if rendition selection is unavailable.
 *
 * @cssproperty [--media-rendition-menu-button-display = inline-flex] - `display` property of button.
 */
export class MediaRenditionMenuButton extends MediaChromeMenuButton {
    constructor();
    set mediaRenditionSelected(arg: string);
    /**
     * Get selected rendition id.
     * @return {string}
     */
    get mediaRenditionSelected(): string;
}
import { MediaChromeMenuButton } from "./media-chrome-menu-button.js";
